package pieces;

import ship.ShipZones;
import spaceAlert.GamePieceCreator;
import VASSAL.build.module.Map;
import VASSAL.build.module.map.boardPicker.board.Region;
import VASSAL.command.Command;
import VASSAL.command.RemovePiece;
import VASSAL.counters.GamePiece;

public abstract class PieceBase {
	protected GamePiece piece;
	public GamePiece getPiece() {
		return piece;
	}
	
	public void moveTo(String location) {
		Map map = piece.getMap();
		Region region = map.findRegion(location);
		moveTo(region);
	}
	
	public void moveTo(ShipZones zone) {
		Map map = piece.getMap();
		map.placeOrMerge(piece, zone.getOrigin(map));
	}
	
	public void moveTo(Region region) {
		Map map = piece.getMap();
		map.placeOrMerge(piece, region.getOrigin());
	}
	
	public void delete() {
		Command c = new RemovePiece(piece);
		c.execute();
	}
	
	protected PieceBase(Map map, String name) {
		GamePieceCreator gamePieceCreator = GamePieceCreator.getInstance();
		piece = gamePieceCreator.get(name);
		map.addPiece(piece);
	}
}
