package ship;

import spaceAlert.GamePieceCreator;
import VASSAL.build.module.Map;
import VASSAL.command.Command;
import VASSAL.command.RemovePiece;
import VASSAL.counters.GamePiece;

public class Battlebots extends ShipComponentBase implements Damageable {
	protected GamePiece piece;
	
	protected boolean destroyed = false;
	public boolean isDestroyed() {
		return destroyed;
	}
	
	protected boolean damaged = false;
	public boolean isDamaged() {
		return damaged;
	}
	public void damage() {
		if (!destroyed) {
			damaged = true;
			if (following != null) {
				following.setProperty("battlebots", 2);
			} else {
				piece.setProperty("damaged", 1);
			}
		}
	}
	public void repair() {
		if (!destroyed) {
			damaged = false;
			if (following != null) {
				following.setProperty("battlebots", 1);
			} else {
				piece.setProperty("damaged", 0);
			}
		}
	}
	
	protected GamePiece following = null;
	public boolean follow(GamePiece player) {
		if (destroyed) {
			return false;
		} else {
			if (following == null) {
				following = player;
				if (!damaged) {
					following.setProperty("battlebots", 1);
				} else {
					following.setProperty("battlebots", 2);
				}
				Command c = new RemovePiece(piece);
				c.execute();
				return true;
			}
			return false;
		}
	}
	public boolean isFollowing() {
		return following != null;
	}
	
	public Battlebots(Map map, boolean inRed, boolean destroyed) {
		super(map);
		this.destroyed = destroyed;
		
		GamePieceCreator gamePieceCreator = GamePieceCreator.getInstance();
		if (!destroyed) {
			if (inRed) {
				piece = gamePieceCreator.get("BattlebotsRed");
				map.addPiece(piece);
				map.placeOrMerge(piece, map.findRegion("Red: Battlebots").getOrigin());
			} else {
				piece = gamePieceCreator.get("BattlebotsBlue");
				map.addPiece(piece);
				map.placeOrMerge(piece, map.findRegion("Blue: Battlebots").getOrigin());
			}
		}
	}
	@Override
	public String getName() {
		return "battlebot squad";
	}

}
