package ship;

import spaceAlert.Log;
import spaceAlert.Nameable;
import spaceAlert.ResetableBase;
import threats.InternalAttachedThreatBase;

public class Computer extends ShipComponentBase {

	public Computer(ResetableBase parent) {
		super(parent);
	}
	
	private int maintained = 0;
	public boolean isMaintained() {
		return maintained > 0;
	}
	public void maintain(Nameable player) {
		InternalAttachedThreatBase threat = getBlocker();
		if (threat != null) {
			threat.damage(player, this, false);
		} else {
			Log.log(player.getName() + " maintains the computer.");
			maintained = 3;
		}
	}
	@Override
	public void reset() {
		super.reset();
		if (maintained > 0) {
			maintained--;
		}
	}
	@Override
	public String getName() {
		return "computer";
	}
}
