package ship;

import java.util.List;

import javax.swing.JOptionPane;

import VASSAL.build.GameModule;

public class InitialDamagedSystems {
	private boolean canceled = false;
	public boolean isCanceled() {
		return canceled;
	}
	
	private boolean redHeavyLaserCannonDamaged = false;
	private boolean redLightLaserCannonDamaged = false;
	private boolean redShieldDamaged = false;
	private boolean redReactorDamaged = false;
	private boolean redStructureDamaged = false;
	private boolean redElevatorDamaged = false;
	private boolean redBattlebotSquadDestroyed = false;

	private boolean whiteHeavyLaserCannonDamaged = false;
	private boolean whiteShieldDamaged = false;
	private boolean whiteReactorDamaged = false;
	private boolean whiteStructureDamaged = false;
	private boolean whiteElevatorDamaged = false;
	private boolean pulseCannonDamaged = false;
	
	private boolean blueHeavyLaserCannonDamaged = false;
	private boolean blueLightLaserCannonDamaged = false;
	private boolean blueShieldDamaged = false;
	private boolean blueReactorDamaged = false;
	private boolean blueStructureDamaged = false;
	private boolean blueElevatorDamaged = false;
	private boolean blueBattlebotSquadDestroyed = false;
	
	private List<ShipDamage> damagedSystems;
	public List<ShipDamage> getDamagedSystems() {
		return damagedSystems;
	}
	
	public InitialDamagedSystems(List<ShipDamage> damagedSystems, int numberOfBattlebotSquads) {
		this.damagedSystems = damagedSystems;
		for (ShipDamage damage: damagedSystems) {
			switch (damage) {
			case BLUE_ELEVATOR:
				blueElevatorDamaged = true;
				break;
			case BLUE_HEAVY_LASER_CANNON:
				blueHeavyLaserCannonDamaged = true;
				break;
			case BLUE_LIGHT_LASER_CANNON:
				blueLightLaserCannonDamaged = true;
				break;
			case BLUE_REACTOR:
				blueReactorDamaged = true;
				break;
			case BLUE_SHIELD:
				blueShieldDamaged = true;
				break;
			case BLUE_STRUCTURE:
				blueStructureDamaged = true;
				break;
			case RED_ELEVATOR:
				redElevatorDamaged = true;
				break;
			case RED_HEAVY_LASER_CANNON:
				redHeavyLaserCannonDamaged = true;
				break;
			case RED_LIGHT_LASER_CANNON:
				redLightLaserCannonDamaged = true;
				break;
			case RED_REACTOR:
				redReactorDamaged = true;
				break;
			case RED_SHIELD:
				redShieldDamaged = true;
				break;
			case RED_STRUCTURE:
				redStructureDamaged = true;
				break;
			case WHITE_ELEVATOR:
				whiteElevatorDamaged = true;
				break;
			case WHITE_HEAVY_LASER_CANNON:
				whiteHeavyLaserCannonDamaged = true;
				break;
			case WHITE_PULSE_CANNON:
				pulseCannonDamaged = true;
				break;
			case WHITE_REACTOR:
				whiteReactorDamaged = true;
				break;
			case WHITE_SHIELD:
				whiteShieldDamaged = true;
				break;
			case WHITE_STRUCTURE:
				whiteStructureDamaged = true;
				break;
			case DESTROYED:
			default:
				break;
			}
		}
		if (numberOfBattlebotSquads == 0) {
			this.redBattlebotSquadDestroyed = true;
			this.blueBattlebotSquadDestroyed = true;
		} else if (numberOfBattlebotSquads > 1) {
			this.redBattlebotSquadDestroyed = false;
			this.blueBattlebotSquadDestroyed = false;
		} else if (numberOfBattlebotSquads == 1) {
		    int dialogResult = JOptionPane.showOptionDialog(GameModule.getGameModule().getFrame(),
		    		"One battlebot squad has been destroyed.\n" +
		    		"Please select the location for the remaining squad.", "Destroyed Battlebot Squad",
	                JOptionPane.YES_NO_OPTION,
	                JOptionPane.QUESTION_MESSAGE, null, 
	                new String[]{"Red", "Blue"}, "Red");

		    switch (dialogResult) {
		    case JOptionPane.YES_OPTION:
				this.redBattlebotSquadDestroyed = false;
				this.blueBattlebotSquadDestroyed = true;
		    	break;
		    case JOptionPane.NO_OPTION:
				this.redBattlebotSquadDestroyed = true;
				this.blueBattlebotSquadDestroyed = false;
		    	break;
		    default:
		    	canceled = true;
		    	break;
		    }
		}
	}

	public boolean isRedHeavyLaserCannonDamaged() {
		return redHeavyLaserCannonDamaged;
	}

	public boolean isRedLightLaserCannonDamaged() {
		return redLightLaserCannonDamaged;
	}

	public boolean isRedShieldDamaged() {
		return redShieldDamaged;
	}

	public boolean isRedReactorDamaged() {
		return redReactorDamaged;
	}

	public boolean isRedStructureDamaged() {
		return redStructureDamaged;
	}

	public boolean isRedElevatorDamaged() {
		return redElevatorDamaged;
	}
	
	public boolean isRedBattlebotSquadDestroyed() {
		return redBattlebotSquadDestroyed;
	}

	public boolean isWhiteHeavyLaserCannonDamaged() {
		return whiteHeavyLaserCannonDamaged;
	}

	public boolean isWhiteShieldDamaged() {
		return whiteShieldDamaged;
	}

	public boolean isWhiteReactorDamaged() {
		return whiteReactorDamaged;
	}

	public boolean isWhiteStructureDamaged() {
		return whiteStructureDamaged;
	}

	public boolean isWhiteElevatorDamaged() {
		return whiteElevatorDamaged;
	}

	public boolean isPulseCannonDamaged() {
		return pulseCannonDamaged;
	}

	public boolean isBlueHeavyLaserCannonDamaged() {
		return blueHeavyLaserCannonDamaged;
	}

	public boolean isBlueLightLaserCannonDamaged() {
		return blueLightLaserCannonDamaged;
	}

	public boolean isBlueShieldDamaged() {
		return blueShieldDamaged;
	}

	public boolean isBlueReactorDamaged() {
		return blueReactorDamaged;
	}

	public boolean isBlueStructureDamaged() {
		return blueStructureDamaged;
	}

	public boolean isBlueElevatorDamaged() {
		return blueElevatorDamaged;
	}
	
	public boolean isBlueBattlebotSquadDestroyed() {
		return blueBattlebotSquadDestroyed;
	}
}
