package ship;

import java.util.LinkedList;
import java.util.List;

import spaceAlert.ResetableBase;
import threats.ThreatZones;

public class Optics extends ResetableBase {
	private boolean visualTargeting = false;
	public void doVisualTargeting() {
		visualTargeting = true;
	}
	
	@Override
	public void reset() {
		super.reset();
		visualTargeting = false;
	}
	
	List<ThreatZones> damagedOptics = new LinkedList<ThreatZones>();
	
	public void damageOptics(ThreatZones zone) {
		damagedOptics.add(zone);
	}
	public void repairOptics() {
		damagedOptics.clear();
	}
	
	public boolean canTargetIn(ThreatZones zone) {
		if (visualTargeting) {
			return true;
		} else {
			return !damagedOptics.contains(zone);
		}
	}
	
	public Optics(Ship ship) {
		super(ship);
	}

}
