package ship;

import pieces.Energy;
import pieces.Fuel;
import spaceAlert.Log;
import spaceAlert.Nameable;
import spaceAlert.ResetableBase;
import threats.InternalAttachedThreatBase;

public class PrimaryReactor extends ReactorBase {
	@Override
	protected int getMaximumEnergy() {
		if (damaged) {
			return 4;
		} else {
			return 5;
		}
	}
	protected Fuel[] fuel = new Fuel[3];
	
	public void consumeFuel() {
		int fuelI = 2;
		while ((fuelI > 0)
		&& (fuel[fuelI] != null)) {
			fuelI--;
		}
		if (fuel[fuelI] != null) {
			fuel[fuelI].delete();
			fuel[fuelI] = null;
		}
	}
	
	public void createEnergy(Nameable player, boolean isHeroic) {
		InternalAttachedThreatBase threat = getBlocker();
		if (threat != null) {
			threat.damage(player, this, isHeroic);
		} else {
			int fuelI = 2;
			while ((fuelI > 0)
			&& (fuel[fuelI] == null)) {
				fuelI--;
			}
			if (fuel[fuelI] != null) {
				fuel[fuelI].delete();
				fuel[fuelI] = null;
				
				while (energies.size() < getMaximumEnergy()) {
					Energy energy = new Energy(map);
					energy.moveTo(location);
					energies.add(energy);
				}
				if (isHeroic) {
					Energy energy = new Energy(map);
					energy.moveTo(location);
					energies.add(energy);
				}
				if (isHeroic) {
					Log.log(player.getName() + " refuels heroic " + getName());	
				} else {
					Log.log(player.getName() + " refuels " + getName());
				}
			} else {
				Log.log(player.getName() + " wants to refuel " + getName() + " but is missing fuel.");
			}
		}
	}
	
	public PrimaryReactor(ResetableBase parent, boolean damaged) {
		super (parent, damaged);
			
		location = map.findRegion("White: Reactor");
		name = "central reactor";
		energies.add(new Energy(map));
		energies.add(new Energy(map));
		if (!damaged) {
			energies.add(new Energy(map));
		}
		for (Energy energy: energies) {
			energy.moveTo(location);
		}
		
		fuel[0] = new Fuel(map);
		fuel[0].moveTo("White: Fuel 1");
		fuel[1] = new Fuel(map);
		fuel[1].moveTo("White: Fuel 2");
		fuel[2] = new Fuel(map);
		fuel[2].moveTo("White: Fuel 3");
	}

}
