package ship;

import java.util.LinkedList;
import java.util.List;

import VASSAL.build.module.map.boardPicker.board.Region;

import pieces.Energy;
import spaceAlert.ResetableBase;

public abstract class ReactorBase extends ShipComponentBase implements Damageable {
	protected Region location;
	protected String name;
	public String getName() {
		return name;
	}
	
	protected boolean damaged = false;
	public boolean isDamaged() {
		return damaged;
	}
	public void damage() {
		damaged = true;
		while (energies.size() > getMaximumEnergy()) {
			Energy energy = energies.remove(0);
			energy.delete();
		}
	}
	
	protected List<Energy> energies = new LinkedList<Energy>();
	protected abstract int getMaximumEnergy();
	
	public List<Energy> getEnergy(int count) {
		List<Energy> removedEnergy = new LinkedList<Energy>();
		
		while ((energies.size() > 0)
		&& (count > 0)) {
			Energy energy = energies.remove(0);
			removedEnergy.add(energy);
			count--;
		}
		
		return removedEnergy;
	}
	public int getEnergyCount() {
		return energies.size();
	}
	
	public void clear() {
		for (Energy energy: energies) {
			energy.delete();
		}
		energies.clear();
	}
	
	public ReactorBase(ResetableBase parent, boolean damaged) {
		super(parent);
		
		this.damaged = damaged;
	}
}
