package ship;

import VASSAL.build.module.Map;
import VASSAL.command.Command;
import VASSAL.command.RemovePiece;
import VASSAL.counters.FreeRotator;
import VASSAL.counters.GamePiece;
import spaceAlert.GamePieceCreator;
import spaceAlert.VassalHelper;

public class Rocket {
	protected GamePiece piece;
	protected Map map;
	
	protected boolean moved = false;
	public boolean hasMoved() {
		return moved;
	}
	public void move() {
		if (!moved) {
			moved = true;
			map.placeOrMerge(piece, map.findRegion("Red: Rocket Target").getOrigin());
			FreeRotator freeRotator = VassalHelper.getFreeRotator(piece);
			if (freeRotator != null) {
				freeRotator.setAngle(-90);
			}
		}
	}
	
	protected boolean fired = false;
	public boolean hasFired() {
		return fired;
	}
	public void fire() {
		fired = true;
		
		map.placeOrMerge(piece, map.findRegion("White: Rocket Shot").getOrigin());
		FreeRotator freeRotator = VassalHelper.getFreeRotator(piece);
		if (freeRotator != null) {
			freeRotator.setAngle(-45);
		}
	}

	protected boolean destroyed = false;
	public boolean isDestroyed() {
		return destroyed;
	}
	public void destroy() {
		if (!destroyed) {
			fired = true;
			moved = true;
			destroyed = true;
			
			Command c = new RemovePiece(piece);
			c.execute();
		}
	}
	
	public Rocket(Map map, String location) {	
		piece = GamePieceCreator.getInstance().get("Rocket");
		this.map = map;
		map.addPiece(piece);
		map.placeOrMerge(piece, map.findRegion(location).getOrigin());
	}
}
