package ship;

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import VASSAL.build.module.Map;

import spaceAlert.Nameable;
import spaceAlert.ResetableBase;
import threats.InternalAttachedThreatBase;
import threats.ThreatCompareETA;

public abstract class ShipComponentBase extends ResetableBase implements Nameable {
	protected List<InternalAttachedThreatBase> blockedBy = new LinkedList<InternalAttachedThreatBase>();
	protected InternalAttachedThreatBase getBlocker() {
		for (InternalAttachedThreatBase threat : blockedBy) {
			if (threat.isAppeared()
			&& !threat.isDestroyed()) {
				return threat;
			}
		}
		return null;
	}
	public void block(InternalAttachedThreatBase threat) {
		blockedBy.add(threat);
		Collections.sort(blockedBy, new ThreatCompareETA());
	}
	
	public abstract String getName();
	
	public ShipComponentBase(ResetableBase parent) {
		super(parent);
	}

	public ShipComponentBase(Map map) {
		super(map);
	}

}
