package ship;

import threats.ThreatZones;

public enum ShipDamage {
	RED_LIGHT_LASER_CANNON,
	RED_HEAVY_LASER_CANNON,
	RED_SHIELD,
	RED_REACTOR,
	RED_STRUCTURE,
	RED_ELEVATOR,
	
	WHITE_PULSE_CANNON,
	WHITE_HEAVY_LASER_CANNON,
	WHITE_SHIELD,
	WHITE_REACTOR,
	WHITE_STRUCTURE,
	WHITE_ELEVATOR,
	
	BLUE_LIGHT_LASER_CANNON,
	BLUE_HEAVY_LASER_CANNON,
	BLUE_SHIELD,
	BLUE_REACTOR,
	BLUE_STRUCTURE,
	BLUE_ELEVATOR,
	
	DESTROYED;
	
	public static ShipDamage getDamage(String name) {
		for (ShipDamage damage: ShipDamage.values()) {
			if (damage.toString().equals(name)) {
				return damage;
			}
		}
		return ShipDamage.DESTROYED;
	}
	
	public ThreatZones getZone() {
		switch (this) {
		case BLUE_ELEVATOR:
		case BLUE_HEAVY_LASER_CANNON:
		case BLUE_LIGHT_LASER_CANNON:
		case BLUE_REACTOR:
		case BLUE_SHIELD:
		case BLUE_STRUCTURE:
			return ThreatZones.BLUE;
		case RED_ELEVATOR:
		case RED_HEAVY_LASER_CANNON:
		case RED_LIGHT_LASER_CANNON:
		case RED_REACTOR:
		case RED_SHIELD:
		case RED_STRUCTURE:
			return ThreatZones.RED;
		case WHITE_ELEVATOR:
		case WHITE_HEAVY_LASER_CANNON:
		case WHITE_PULSE_CANNON:
		case WHITE_REACTOR:
		case WHITE_SHIELD:
		case WHITE_STRUCTURE:
			return ThreatZones.WHITE;
		case DESTROYED:
		default:
			return null;
		}
	}
	
	@Override
	public String toString() {
		switch (this) {
		case BLUE_ELEVATOR:
			return "damage_blue_elevator";
		case BLUE_HEAVY_LASER_CANNON:
			return "damage_blue_heavy_laser";
		case BLUE_LIGHT_LASER_CANNON:
			return "damage_blue_light_laser";
		case BLUE_REACTOR:
			return "damage_blue_reactor";
		case BLUE_SHIELD:
			return "damage_blue_shield";
		case BLUE_STRUCTURE:
			return "damage_blue_structural";
		case RED_ELEVATOR:
			return "damage_red_elevator";
		case RED_HEAVY_LASER_CANNON:
			return "damage_red_heavy_laser";
		case RED_LIGHT_LASER_CANNON:
			return "damage_red_light_laser";
		case RED_REACTOR:
			return "damage_red_reactor";
		case RED_SHIELD:
			return "damage_red_shield";
		case RED_STRUCTURE:
			return "damage_red_structural";
		case WHITE_ELEVATOR:
			return "damage_white_elevator";
		case WHITE_HEAVY_LASER_CANNON:
			return "damage_white_heavy_laser";
		case WHITE_PULSE_CANNON:
			return "damage_white_pulse_cannon";
		case WHITE_REACTOR:
			return "damage_white_reactor";
		case WHITE_SHIELD:
			return "damage_white_shield";
		case WHITE_STRUCTURE:
			return "damage_white_structural";
		default:
			return "";
		}
	}
}
