package ship;

import java.awt.Point;

import threats.ThreatZones;

import VASSAL.build.module.Map;

public enum ShipZones {
	RED_UPPER,
	RED_LOWER,
	WHITE_UPPER,
	WHITE_LOWER,
	BLUE_UPPER,
	BLUE_LOWER,
	FIGHTERS;
	
	@Override
	public String toString() {
		switch (this) {
		case BLUE_LOWER:
			return "Blue: Lower";
		case BLUE_UPPER:
			return "Blue: Upper";
		case FIGHTERS:
			return "Space: Fighters";
		case RED_LOWER:
			return "Red: Lower";
		case RED_UPPER:
			return "Red: Upper";
		case WHITE_LOWER:
			return "White: Lower";
		case WHITE_UPPER:
			return "White: Upper";
		default:
			return "";		
		}
	}
	
	public String getName() {
		switch (this) {
		case BLUE_LOWER:
			return "lower blue station";
		case BLUE_UPPER:
			return "upper blue station";
		case FIGHTERS:
			return "space";
		case RED_LOWER:
			return "lower red station";
		case RED_UPPER:
			return "upper red station";
		case WHITE_LOWER:
			return "lower white station";
		case WHITE_UPPER:
			return "upper white station";
		default:
			return "";		
		}
	}
	
	public boolean isUpper() {
		switch (this) {
		case BLUE_UPPER:
		case WHITE_UPPER:
		case RED_UPPER:
			return true;
		case BLUE_LOWER:
		case WHITE_LOWER:			
		case RED_LOWER:
		case FIGHTERS:
		default:
			return false;		
		}
	}
	
	public Point getOrigin(Map map) {
		return map.findRegion(this.toString()).getOrigin();
	}
	
	public ShipZones[] getNeighbour() {
		ShipZones[] neighbour;
		switch (this) {
		case BLUE_LOWER:
			neighbour = new ShipZones[2];
			neighbour[0] = ShipZones.BLUE_UPPER;
			neighbour[1] = ShipZones.WHITE_LOWER;
			break;
		case BLUE_UPPER:
			neighbour = new ShipZones[2];
			neighbour[0] = ShipZones.BLUE_LOWER;
			neighbour[1] = ShipZones.WHITE_UPPER;
			break;
		case RED_LOWER:
			neighbour = new ShipZones[2];
			neighbour[0] = ShipZones.RED_UPPER;
			neighbour[1] = ShipZones.WHITE_LOWER;
			break;
		case RED_UPPER:
			neighbour = new ShipZones[2];
			neighbour[0] = ShipZones.RED_LOWER;
			neighbour[1] = ShipZones.WHITE_UPPER;
			break;
		case WHITE_LOWER:
			neighbour = new ShipZones[3];
			neighbour[0] = ShipZones.BLUE_LOWER;
			neighbour[1] = ShipZones.WHITE_UPPER;
			neighbour[2] = ShipZones.RED_LOWER;
			break;
		case WHITE_UPPER:
			neighbour = new ShipZones[3];
			neighbour[0] = ShipZones.BLUE_UPPER;
			neighbour[1] = ShipZones.WHITE_LOWER;
			neighbour[2] = ShipZones.RED_UPPER;
			break;
		case FIGHTERS:
		default:
			neighbour = new ShipZones[0];
			break;
		}
		return neighbour;
	}
	
	public ThreatZones getThreatZone() {
		switch (this) {
		case BLUE_LOWER:
		case BLUE_UPPER:
			return ThreatZones.BLUE;
		case RED_LOWER:
		case RED_UPPER:
			return ThreatZones.RED;
		case WHITE_LOWER:
		case WHITE_UPPER:
			return ThreatZones.WHITE;
		default:
			return ThreatZones.INTERNAL;		
		}
	}
}
