package ship;

import spaceAlert.Log;
import spaceAlert.Nameable;
import spaceAlert.ResetableBase;

public abstract class WeaponBase extends ShipComponentBase {
	public WeaponRanges getRange() {
		return WeaponRanges.Range3;
	}
	
	public abstract int getDamage();
	
	protected boolean fired = false;
	protected boolean firesHeroic = false;
	public boolean hasFired() {
		return fired;
	}
	public void fire(Nameable player, boolean isHeroic) {
		if (!fired) {
			if (isHeroic) {
				Log.log(player.getName() + " fires heroic " + getName() + ".");
			} else {
				Log.log(player.getName() + " fires " + getName() + ".");
			}
			fired = true;
			firesHeroic = isHeroic;
		} else {
			Log.log(player.getName() + " tries to fire " + getName() + " but it was already activated");
		}
	}
	
	@Override
	public void reset() {
		super.reset();
		
		fired = false;
		firesHeroic = false;
	}
	
	public WeaponBase(ResetableBase parent) {
		super(parent);
	}

}
