package ship;

import java.util.List;
import pieces.Energy;
import spaceAlert.Log;
import spaceAlert.Nameable;
import threats.InternalAttachedThreatBase;

public abstract class WeaponRequiringReactorBase extends WeaponDamageableBase {
	ReactorBase reactor;
	Energy usedEnergy;

	@Override
	public void fire(Nameable player, boolean isHeroic) {
		InternalAttachedThreatBase threat = getBlocker();
		if (threat != null) {
			threat.damage(player, this, isHeroic);
		} else {
			if (!fired) {
				List<Energy> energies = reactor.getEnergy(1);
				if (energies.size() == 1) {
					usedEnergy = energies.get(0);
					usedEnergy.moveTo(location);
					
					super.fire(player, isHeroic);
				} else {
					Log.log(player.getName() + " tries to fire " + getName() + " but there is not enough energy available.");
				}
			}
		}
	}
	
	@Override
	public void reset() {
		super.reset();
		
		if (usedEnergy != null) {
			usedEnergy.delete();
			usedEnergy = null;
		}
	}
	
	public WeaponRequiringReactorBase(ReactorBase reactor, String location, boolean damaged) {
		super(reactor, location, damaged);
		
		this.reactor = reactor;
	}

}
