package ship;

import pieces.EnergyPack;
import spaceAlert.Nameable;
import spaceAlert.ResetableBase;
import threats.InternalAttachedThreatBase;
import VASSAL.build.module.map.boardPicker.board.Region;

public abstract class WeaponWithEnergyPack extends WeaponDamageableBase {
	EnergyPack energyPack;
	Region energyPackRegion;
	
	@Override
	public void fire(Nameable player, boolean isHeroic) {
		InternalAttachedThreatBase threat = getBlocker();
		if (threat != null) {
			threat.damage(player, this, isHeroic);
		} else {
			if (!fired) {
				energyPack.moveTo(location);
				super.fire(player, isHeroic);
			}
		}
	}
	
	protected void createEnergyPack(String energyPackRegion) {
		this.energyPackRegion = map.findRegion(energyPackRegion);
			
		energyPack = new EnergyPack(map);
		energyPack.moveTo(this.energyPackRegion);		
	}
	
	@Override
	public void reset() {
		super.reset();
		
		energyPack.moveTo(energyPackRegion);
	}
	
	public WeaponWithEnergyPack(ResetableBase parent, String location, boolean damaged) {
		super(parent, location, damaged);
	}

}
