package ship;

import spaceAlert.Log;
import spaceAlert.Nameable;
import threats.InternalAttachedThreatBase;

public class Window extends ShipComponentBase {
	protected int[] values = {0, 1, 2, 3, 5, 7, 9, 11};
	protected int[] viewer = {0, 0, 0};
	
	protected int currentViewer = 0;
	protected int currentPhase = 0;
	public void setCurrentPhase(int value) {
		currentPhase = value - 1;
	}
	
	protected Optics optics;
	
	public void lookThrough(Nameable player) {
		InternalAttachedThreatBase threat = getBlocker();
		if (threat != null) {
			threat.damage(player, this, false);
		} else {
			optics.doVisualTargeting();
			currentViewer++;
			Log.log(player.getName() + " makes a visual confirmation.");
		}
	}
	
	@Override
	public void reset() {
		super.reset();
		
		if (currentViewer > viewer[currentPhase]) {
			viewer[currentPhase] = currentViewer;
		}
		currentViewer = 0;
	}
	
	public int getScore() {
		int score = 0;
		for (int i = 0; i < 3; i++) {
			score += values[viewer[i]];
		}
		return score;
	}
	
	public Window(Optics optics) {
		super(optics);
		
		this.optics = optics;
	}

	@Override
	public String getName() {
		return "window";
	}
}
