package spaceAlert;

import java.util.List;

import VASSAL.build.AbstractConfigurable;
import VASSAL.build.Buildable;
import VASSAL.build.GameModule;
import VASSAL.build.module.GameComponent;
import VASSAL.build.module.PieceWindow;
import VASSAL.build.module.documentation.HelpFile;
import VASSAL.build.widget.PieceSlot;
import VASSAL.command.Command;
import VASSAL.counters.Decorator;
import VASSAL.counters.GamePiece;
import VASSAL.counters.PieceCloner;
import VASSAL.counters.Properties;

public class GamePieceCreator extends AbstractConfigurable implements GameComponent {
	private static GamePieceCreator instance;
	public static GamePieceCreator getInstance() {
		if (instance == null) {
			List<GamePieceCreator> creator = GameModule.getGameModule().getAllDescendantComponentsOf(GamePieceCreator.class);
			if (!creator.isEmpty()) {
				instance = creator.get(0);
			}			
		}
		return instance;
	}
	
	private PieceWindow piecePalette;
	
	private GamePiece getCloneOf(GamePiece piece) {
//		GamePiece outer = Decorator.getOutermost(piece);
//		GameModule gameModule = GameModule.getGameModule();
//		GamePiece newPiece = ((AddPiece)gameModule.decode(gameModule.encode(new AddPiece(outer)))).getTarget();
//		newPiece.setId(null);
//		gameModule.getGameState().addPiece(newPiece);
//		newPiece.setState(outer.getState());
		
		GamePiece outer = Decorator.getOutermost(piece);
		GamePiece newPiece = PieceCloner.getInstance().clonePiece(outer);
		newPiece.setProperty(Properties.PIECE_ID, GameModule.getGameModule().generateGpId());
		return newPiece;
	}

	public GamePiece get(String name) {
		List<PieceSlot> slots = piecePalette.getAllDescendantComponentsOf(PieceSlot.class);
		for (PieceSlot slot: slots) {
			GamePiece piece = slot.getPiece();
			if (name.equals(piece.getName())) {
				return getCloneOf(piece);
			}
		}
		Log.log("GamePieceCreator: Couldn't find GamePiece: " + name);
		return null;
	}
	
	public void setup(boolean gameStarting) {
	}
	
	public void addTo(Buildable parent) {
		GameModule mod = GameModule.getGameModule();
		piecePalette = (PieceWindow)parent;
		
		mod.getGameState().addGameComponent(this);
	}

	public void removeFrom(Buildable parent) {
		GameModule mod = GameModule.getGameModule();
		
		mod.getGameState().removeGameComponent(this);
	}

	public HelpFile getHelpFile() {
		return null;
	}

	public Class[] getAllowableConfigureComponents() {
		return new Class[0];
	}

	public Command getRestoreCommand() {
		return null;
	}

	@Override
	public String[] getAttributeDescriptions() {
		// TODO Auto-generated method stub
		return new String[]{};
	}

	@Override
	public Class<?>[] getAttributeTypes() {
		// TODO Auto-generated method stub
		return new Class[]{};
	}

	@Override
	public String[] getAttributeNames() {
		// TODO Auto-generated method stub
		 return new String[]{};
	}

	@Override
	public void setAttribute(String key, Object value) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getAttributeValueString(String key) {
		// TODO Auto-generated method stub
		return null;
	}
}
