package spaceAlert;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import VASSAL.counters.GamePiece;

public class PlayerCardsOrdered implements Iterable<PlayersCards> {
	private List<PlayersCards> players = new ArrayList<PlayersCards>();
	
	public PlayerCardsOrdered(GamePiece missionControl, PlayersCards playersCards[]) {
		PlayerColor colors[] = new PlayerColor[5]; //contains used colors
		for (int i = 0; i < colors.length; i++) {
			colors[i] = null;
		}
		boolean result = setColor(colors, (String) missionControl.getProperty("playerBlue"), PlayerColor.BLUE);
		result &= setColor(colors, (String) missionControl.getProperty("playerGreen"), PlayerColor.GREEN);
		result &= setColor(colors, (String) missionControl.getProperty("playerPurple"), PlayerColor.PURPLE);
		result &= setColor(colors, (String) missionControl.getProperty("playerRed"), PlayerColor.RED);
		result &= setColor(colors, (String) missionControl.getProperty("playerYellow"), PlayerColor.YELLOW);
		
		if (!result) {
			// TODO Fehlerbehandlung
		}

		//sort playersCards by color
		PlayersCards playersCardsSorted[] = new PlayersCards[5];
		for (int i = 0; i < playersCards.length; i++) {
			playersCardsSorted[playersCards[i].getColor().ordinal()] = playersCards[i];
		}
		
		for (PlayerColor color: colors) {
			if (color != null) {
				players.add(playersCardsSorted[color.ordinal()]);
			}
		}
	}

	private boolean setColor(PlayerColor[] colors, String value, PlayerColor color) {
		try {
			int i = Integer.valueOf(value) - 1;
			if (colors[i] != null) {
				return false;
 			}
 			colors[i] = color;
		} catch (NumberFormatException e) {}
		return true;
	}

	public Iterator<PlayersCards> iterator() {
		return players.iterator();
	}
	
	public PlayersCards get(PlayerColor color) {
		for (PlayersCards player: players) {
			if (player.getColor() == color) {
				return player;
			}
		}
		return null;
	}

}
