package spaceAlert;

import java.util.LinkedList;
import java.util.List;

import VASSAL.build.module.Map;

public abstract class ResetableBase {
	private List<ResetableBase> childs = new LinkedList<ResetableBase>();
	
	public void addChild(ResetableBase child) {
		childs.add(child);
	}
	
	public void clear() {
		for (ResetableBase child: childs) {
			child.clear();
		}
		childs.clear();
	}
	
	public void reset() {
		for (ResetableBase child: childs) {
			child.reset();
		}
	}
	
	protected Map map;
	public Map getMap() {
		return map;
	}
	
	public ResetableBase(ResetableBase parent) {
		parent.addChild(this);
		map = parent.getMap();
	}

	public ResetableBase(Map map) {
		this.map = map;
	}
}
