package spaceAlert;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.Thread.UncaughtExceptionHandler;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;

public class ResolutionThreadExceptionHandler extends JDialog implements
		UncaughtExceptionHandler {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -8114887709609961148L;
	private final JPanel contentPanel = new JPanel();
	private final JTextArea textArea = new JTextArea();
	
	public ResolutionThreadExceptionHandler() {
		setModal(true);
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		setTitle("Unexpected error in module \"Space Alert\"");
		setBounds(100, 100, 450, 300);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setLayout(new FlowLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		{
			JLabel lblNewLabel = new JLabel("<html>\r\n<p>Sadly, an unexpected error occured during resolving.</p>\r\n<p>To prevent this happen again, please provide the following stack trace</p>\r\n<p>and a save game of the current game.</p>");
			lblNewLabel.setHorizontalAlignment(SwingConstants.LEFT);
			contentPanel.add(lblNewLabel);
		}
		{
			textArea.setEditable(false);
			textArea.setWrapStyleWord(true);
			textArea.setColumns(30);
			textArea.setRows(8);
			contentPanel.add(textArea);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						setVisible(false);						
					}					
				});
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
		}
	}
		
	private String stackTraceToString(Throwable e) {
	    StringBuilder sb = new StringBuilder();
	    for (StackTraceElement element : e.getStackTrace()) {
	        sb.append(element.toString());
	        sb.append("\n");
	    }
	    return sb.toString();
	}

	public void uncaughtException(Thread arg0, Throwable arg1) {
		((ResolutionThread)arg0).stopThread();
		
		textArea.setText(stackTraceToString(arg1));
		
		setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		setVisible(true);
	}

}
