package spaceAlert;

import VASSAL.counters.Decorator;
import VASSAL.counters.FreeRotator;
import VASSAL.counters.GamePiece;
import VASSAL.counters.Properties;
import VASSAL.counters.Stack;

public class VassalHelper {
		
	public static String getPropertyFromPieceInStack(GamePiece piece, String key) {
		if (piece instanceof Stack) {
			if (((Stack) piece).getPieceCount() != 1) {
				return null;
			}
			piece = ((Stack) piece).getPieceAt(0);
		}
		String prop = null;
		piece = Decorator.getOutermost(piece);
		prop = (String) piece.getProperty(key);
		if (prop != null) {
			return prop;
		}
		return prop;
	}
	
	public static FreeRotator getFreeRotator(GamePiece piece) {
		if (piece instanceof Stack) {
			if (((Stack) piece).getPieceCount() != 1) {
				return null;
			}
			piece = ((Stack) piece).getPieceAt(0);
		}
		piece = Decorator.getInnermost(piece);
    	do {
	       	if (FreeRotator.class.isInstance(piece)) {
	    		return (FreeRotator) piece;
	    	}
	       	piece = (GamePiece) piece.getProperty(Properties.OUTER);
	    } while (piece != null);
	    return (FreeRotator) Decorator.getDecorator(piece, FreeRotator.class);
	}

}
