package threats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import trajectoryBoards.TrajectoryBoardBase;

public abstract class ExternalThreatBase extends ThreatBase {
	protected boolean targetableByRockets = true;
	public boolean isTargetableByRockets() {
		return targetableByRockets;
	}
	
	protected boolean targetableByHeavyLaser = true;
	public boolean isTargetableHeavyLaser() {
		return targetableByHeavyLaser;
	}
	
	@Override
	public void decreaseHealth(int decreaseBy) {
		super.decreaseHealth(decreaseBy);
	}
	private int shield;
	protected int getShield() {
		return shield;
	}
	protected void setShield(int shield) {
		this.shield = shield;
		piece.setProperty("shield", String.valueOf(shield));
	}
	public void increaseShield(int increaseBy) {
		setShield(getShield() + increaseBy);
	}
	public void decreaseShield(int decreaseBy) {
		setShield(getShield() - decreaseBy);
	}
	protected int remainingShield;
		
	public void damageBy(WeaponBase weapon) {
		Log.log(getName() + " gets hit by " + weapon.getName());
		
		int damage = weapon.getDamage();
		if (remainingShield - damage >= 0) {
			remainingShield -= damage;
		} else {
			damage -= remainingShield;
			remainingShield = 0;
			setHealth(getHealth() - damage);
		}
	}
	
	@Override
	public void reset() {
		super.reset();
		
		remainingShield = shield;
	}
	
	@Override
	public void appear() {
		if (!isAppeared()) {
			super.appear();
			Log.log(getName() + " appears at zone " + getZone().getName() + ".");
		}
	}
	
	public ExternalThreatBase(Ship ship, GamePiece piece, TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
	}
}
