package threats;

import ship.Ship;
import ship.ShipComponentBase;
import spaceAlert.Log;
import spaceAlert.Nameable;
import trajectoryBoards.TrajectoryBoardBase;
import VASSAL.counters.GamePiece;

public abstract class InternalAttachedShieldedThreatBase extends
		InternalAttachedThreatBase {
	
	private int shield;
	protected int getShield() {
		return shield;
	}
	protected void setShield(int shield) {
		this.shield = shield;
		piece.setProperty("shield", String.valueOf(shield));
	}
	public void increaseShield(int increaseBy) {
		setShield(getShield() + increaseBy);
	}
	public void decreaseShield(int decreaseBy) {
		setShield(getShield() - decreaseBy);
	}
	protected int remainingShield;
	
	@Override
	public void damage(Nameable player, ShipComponentBase station, boolean isHeroic) {
		if (isHeroic) {
			Log.log(player.getName() + " attacks heroics " + getName() + " by activating " + station.getName() + ".");
		} else {
			Log.log(player.getName() + " attacks " + getName() + " by activating " + station.getName() + ".");
		}
		
		int damage = 1;
		if (isHeroic) {
			damage++;
		}
		if (remainingShield - damage >= 0) {
			remainingShield -= damage;
		} else {
			damage -= remainingShield;
			remainingShield = 0;
			setHealth(getHealth() - damage);
		}
	}
	
	@Override
	public void reset() {
		super.reset();
		
		remainingShield = shield;
	}

	public InternalAttachedShieldedThreatBase(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
	}
}
