package threats;

import ship.Ship;
import ship.ShipComponentBase;
import spaceAlert.Log;
import spaceAlert.Nameable;
import trajectoryBoards.TrajectoryBoardBase;
import VASSAL.counters.GamePiece;

public abstract class InternalAttachedThreatBase extends InternalThreatBase {
	protected String action;
	protected ShipComponentBase attachedTo;
	
	public void damage(Nameable player, ShipComponentBase station, boolean isHeroic) {
		if (isHeroic) {
			Log.log(player.getName() + " attacks heroic " + getName() + " by activating " + station.getName() + ".");
			setHealth(getHealth() - 2);		
		} else {
			Log.log(player.getName() + " attacks " + getName() + " by activating " + station.getName() + ".");
			setHealth(getHealth() - 1);
		}
	}
	
	@Override
	public void appear() {
		if (!isAppeared()) {
			attachedTo.block(this);
			super.appear();
		}
	}
	
	@Override
	public void createToken() {
		tokenName = "Token " + action;
		
		super.createToken();
		
		map.placeOrMerge(token, map.findRegion(location.toString() + ": " + action).getOrigin());
	}
	
	public InternalAttachedThreatBase(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
	}

}
