package threats;

import ship.Moveable;
import ship.Player;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import trajectoryBoards.TrajectoryBoardBase;
import VASSAL.counters.GamePiece;

public abstract class InternalMovingThreatBase extends InternalThreatBase implements Moveable {
	public ShipZones getLocation() {
		return location;
	}
	
	protected boolean fightsBack = false;
	protected boolean staysAfterPassingBy = false;
	
	public InternalMovingThreatBase(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
	}
	
	public void damageBy(Player player, boolean isHeroic) {
		if (player.hasBattlebots()
		&& !player.getBattlebots().isDamaged()) {		
			if (isHeroic) {
				Log.log(getName() + " gets attacked heroic by " + player.getName() + ".");
			} else {
				if (fightsBack) {
					player.getBattlebots().damage();
					Log.log(getName() + " gets attacked by " + player.getName() + " and damages the battlebot squad.");
				} else {
					Log.log(getName() + " gets attacked by " + player.getName() + ".");
				}
			}
			setHealth(getHealth() - 1);
		}
	}
	
	@Override
	public void createToken() {
		super.createToken();
		
		map.placeOrMerge(token, location.getOrigin(map));
	}

	@Override
	protected void passeBy() {
		passedBy = true;
		piece.setProperty("evaded", 1);
		if (!staysAfterPassingBy) {
			deleteToken();
		}
	}
	
	public void moveTo(ShipZones location) {
		this.location = location;
		map.placeOrMerge(token, location.getOrigin(map));
	}
}
