package threats;

import java.util.ArrayList;
import java.util.List;

import ship.Ship;
import ship.ShipComponentBase;
import ship.ShipZones;
import spaceAlert.GamePieceCreator;
import trajectoryBoards.TrajectoryBoardBase;
import VASSAL.command.Command;
import VASSAL.command.RemovePiece;
import VASSAL.counters.GamePiece;

public abstract class InternalMultipleAttachedThreatBase extends InternalAttachedThreatBase {
	protected List<GamePiece> additionalToken = new ArrayList<GamePiece>();
	protected List<ShipZones> additionalLocation = new ArrayList<ShipZones>();
	protected List<ShipComponentBase> additionalAttachedTo = new ArrayList<ShipComponentBase>();

	@Override
	public void appear() {
		if (!isAppeared()) {
			super.appear();
			
			for (ShipComponentBase attachedTo: additionalAttachedTo) {
				attachedTo.block(this);
			}
		}
	}
	
	@Override
	public void createToken() {	
		super.createToken();
		for (int i = 0; i < additionalLocation.size(); i++) {
			GamePiece addToken = GamePieceCreator.getInstance().get(tokenName);
			additionalToken.add(addToken);
			map.addPiece(addToken);
			map.placeOrMerge(addToken, map.findRegion(additionalLocation.get(i).toString() + ": " + action).getOrigin());
		}
	}
	
	@Override
	protected void deleteToken() {
		super.deleteToken();
		
		if (additionalToken.size() > 0) {
			for (GamePiece token: additionalToken) {
				Command c = new RemovePiece(token);
				c.execute();
			}
			additionalToken.clear();
		}
	}
		
	public InternalMultipleAttachedThreatBase(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
	}
}
