package threats;

import ship.Ship;
import ship.ShipZones;
import spaceAlert.GamePieceCreator;
import spaceAlert.Log;
import trajectoryBoards.TrajectoryBoardBase;
import VASSAL.command.Command;
import VASSAL.command.RemovePiece;
import VASSAL.counters.GamePiece;

public abstract class InternalThreatBase extends ThreatBase {
	protected GamePiece token;
	protected String tokenName;
	protected ShipZones location;
	
	@Override
	public ThreatZones getZone() {
		return location.getThreatZone();
	}
	
	@Override
	public void appear() {
		if (!isAppeared()) {
			createToken();
			super.appear();
			Log.log(getName() + " appears at " + location.getName() + ".");
		}
	}
	
	protected void createToken() {
		token = GamePieceCreator.getInstance().get(tokenName);
		map.addPiece(token);
	}
	
	protected void deleteToken() {
		if (token != null) {
			Command c = new RemovePiece(token);
			c.execute();
			token = null;
		}
	}
	
	@Override
	protected void destroy() {
		super.destroy();
		
		deleteToken();
	}

	public InternalThreatBase(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
	}
}
