package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.PulseCannon;
import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class E1_04 extends ExternalThreatBase {
	//Energiewolke
	public E1_04(Ship ship, GamePiece piece, TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 2;
		scoreDestroyed= 4;
		
		setSpeed(2);
		setHealth(5);
		setShield(3);
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " drains all energy from each shield.");
		ship.getRedShield().clear();
		ship.getWhiteShield().clear();
		ship.getBlueShield().clear();
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " attacks 1 on all other two zones.");
		if (getZone() != ThreatZones.RED) {
			ship.shieldedDamage(ThreatZones.RED, 1);
		}
		if (getZone() != ThreatZones.WHITE) {
			ship.shieldedDamage(ThreatZones.WHITE, 1);
		}
		if (getZone() != ThreatZones.BLUE) {
			ship.shieldedDamage(ThreatZones.BLUE, 1);
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks 2 on all other two zones.");
		if (getZone() != ThreatZones.RED) {
			ship.shieldedDamage(ThreatZones.RED, 2);
		}
		if (getZone() != ThreatZones.WHITE) {
			ship.shieldedDamage(ThreatZones.WHITE, 2);
		}
		if (getZone() != ThreatZones.BLUE) {
			ship.shieldedDamage(ThreatZones.BLUE, 2);
		}
	}
	
	@Override
	public void damageBy(WeaponBase weapon) {
		if (weapon instanceof PulseCannon) {
			remainingShield = 0;
		}
		super.damageBy(weapon);
	}

}
