package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class E1_06 extends ExternalThreatBase {
	private boolean cryoshieldActive = true;
	private boolean cryoshieldDamaged = false;
	//Cryoschildjäger
	public E1_06(Ship ship, GamePiece piece, TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 2;
		scoreDestroyed= 4;
		
		setSpeed(3);
		setHealth(4);
		setShield(1);
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks 1.");
		ship.shieldedDamage(getZone(), 1);
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " attacks 2.");
		ship.shieldedDamage(getZone(), 2);
	}

	@Override
	protected void doZAction() {
		doYAction();
	}

	@Override
	public void damageBy(WeaponBase weapon) {
		if (cryoshieldActive) {
			Log.log(getName() + " gets hit by " + weapon.getName() + " but cryoshield shields the damage.");
			cryoshieldDamaged = true;
		} else {		
			super.damageBy(weapon);
		}
	}
	
	@Override
	public void reset() {
		super.reset();
		if (cryoshieldDamaged) {
			cryoshieldActive = false;
		}
	}
}
