package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.RocketThrower;
import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class E1_102 extends ExternalThreatBase {
	//Killerkreissäge
	public E1_102(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 2;
		scoreDestroyed= 4;
		
		setSpeed(3);
		setHealth(3);
		setShield(4);
	}
	
	private boolean wasHitByRocket = false;

	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks 1.");
		ship.shieldedDamage(getZone(), 1);
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " attacks 1.");
		ship.shieldedDamage(getZone(), 1);
	}

	@Override
	protected void doZAction() {
		if (!wasHitByRocket) {
			Log.log(getName() + " attacks 5.");
			ship.shieldedDamage(getZone(), 5);	
		} else {
			Log.log(getName() + " misses the ship.");
		}
	}

	@Override
	public void damageBy(WeaponBase weapon) {
		if (weapon instanceof RocketThrower) {
			wasHitByRocket = true;
		}
		super.damageBy(weapon);
	}
}
