package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Movement;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.CardAction;
import spaceAlert.Log;
import threats.InternalMovingThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class I1_01 extends InternalMovingThreatBase {
	//Nahkämpfer
	public I1_01(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 2;
		scoreDestroyed= 4;
		
		setSpeed(3);
		setHealth(1);
		fightsBack = true;
		tokenName = "Token I1_01|02";
		location = ShipZones.RED_UPPER;
	}

	@Override
	protected void doXAction() {
		Movement.moveTo(this, CardAction.MOVE_TO_BLUE);
	}

	@Override
	protected void doYAction() {
		Movement.moveTo(this, CardAction.SWITCH_DECK);
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 3 damage.");
		ship.damage(location.getThreatZone(), 3);
	}
}
