package whiteThreats;

import java.util.List;

import pieces.Energy;

import VASSAL.counters.GamePiece;
import ship.Movement;
import ship.ReactorBase;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.CardAction;
import spaceAlert.Log;
import threats.InternalMovingThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class I1_03 extends InternalMovingThreatBase {
	//Saboteur
	public I1_03(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 2;
		scoreDestroyed= 4;
		
		setSpeed(4);
		setHealth(1);
		
		tokenName = "Token I1_03|04";
		location = ShipZones.WHITE_LOWER;
	}

	@Override
	protected void doXAction() {
		Movement.moveTo(this, CardAction.MOVE_TO_BLUE);
	}

	@Override
	protected void doYAction() {
		ReactorBase reactor;
		switch (location) {
		case BLUE_LOWER:
		case BLUE_UPPER:
			reactor = ship.getBlueReactor();
			break;
		case RED_LOWER:
		case RED_UPPER:
			reactor = ship.getRedReactor();
			break;
		case WHITE_LOWER:
		case WHITE_UPPER:
		default:
			reactor = ship.getWhiteReactor();
			break;
		}
		List<Energy> energies = reactor.getEnergy(1);
		if (energies.size() < 1) {
			Log.log(getName() + " deals 1 damage.");
			ship.damage(location.getThreatZone(), 1);
		} else {
			Log.log(getName() + " drains 1 energy from " + reactor.getName() + ".");
			for (Energy energy: energies) {
				energy.delete();
			}
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 2 damage.");
		ship.damage(location.getThreatZone(), 2);
	}
}
