package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalAttachedThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class I1_06 extends InternalAttachedThreatBase {
	//Schutzschilde gehackt
	public I1_06(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 2;
		scoreDestroyed= 4;
		
		setSpeed(2);
		setHealth(3);
		
		action = "B";
		location = ShipZones.RED_UPPER;
		attachedTo = ship.getRedShield();
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " drains all energy from " + ship.getRedShield().getName() + ".");
		ship.getRedShield().clear();
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " drains all energy from " + ship.getRedReactor().getName() + ".");
		ship.getRedReactor().clear();
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 3 damage.");
		ship.damage(location.getThreatZone(), 3);
	}

}
