package whiteThreats;

import java.util.List;

import pieces.Energy;
import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalAttachedThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class I1_101 extends InternalAttachedThreatBase {
	//Fehlfunktion mittlere Kanone
	public I1_101(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 2;
		scoreDestroyed= 4;
		
		setSpeed(2);
		setHealth(2);
		
		action = "A";
		location = ShipZones.WHITE_UPPER;
		attachedTo = ship.getWhiteHeavyLaser();
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " drains 1 energy from " + ship.getWhiteReactor().getName() + ".");
		List<Energy> energies = ship.getWhiteReactor().getEnergy(1);
		for (Energy energy: energies) {
			energy.delete();
		}
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " deals 1 damage.");
		ship.damage(location.getThreatZone(), 1);
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 3 damage.");
		ship.damage(getZone(), 3);		
		Log.log(getName() + " deals 1 damage in all other two zones.");
		if (location.getThreatZone() != ThreatZones.RED) {
			ship.damage(ThreatZones.RED, 1);
		}
		if (location.getThreatZone() != ThreatZones.WHITE) {
			ship.damage(ThreatZones.WHITE, 1);
		}
		if (location.getThreatZone() != ThreatZones.BLUE) {
			ship.damage(ThreatZones.BLUE, 1);
		}
	}

}
