package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import spaceAlert.Log;
import spaceAlert.Space;
import threats.ExternalThreatBase;
import threats.ThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SE1_03 extends ExternalThreatBase {
	//Leviathantanker
	public SE1_03(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 4;
		scoreDestroyed= 8;
		
		setSpeed(2);
		setHealth(8);
		setShield(3);
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks 2.");
		ship.shieldedDamage(getZone(), 2);
	}

	@Override
	protected void doYAction() {
		doXAction();
		Log.log(getName() + " heals 2 damage.");
		increaseHealth(2, 8);
	}

	@Override
	protected void doZAction() {
		doXAction();
	}

	@Override
	protected void destroy() {
		super.destroy();
		
		Log.log(getName() + " deals 1 damage to each other external threat.");
		for (ThreatBase threat: Space.getInstance().getThreats()) {
			if (threat instanceof ExternalThreatBase) {
				ExternalThreatBase externalThreat = (ExternalThreatBase) threat;
				if (externalThreat.isAppeared()
				&& !externalThreat.isDestroyed()
				&& !externalThreat.isPassedBy()) {
					externalThreat.decreaseHealth(1);
				}
			}
		}
	}
}
