package whiteThreats;

import ship.Ship;
import ship.WeaponRanges;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;
import VASSAL.counters.GamePiece;

public class SE1_04 extends ExternalThreatBase {
	//Pulswellensatellit
	public SE1_04(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 4;
		scoreDestroyed= 8;
		
		setSpeed(3);
		setHealth(4);
		setShield(2);
		
		if (getDistance() > WeaponRanges.Range2.getMaximumDistance()) {
			targetable = false;
		}
	}
	
	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks 1 on each zone.");
		ship.shieldedDamage(ThreatZones.BLUE, 1);
		ship.shieldedDamage(ThreatZones.WHITE, 1);
		ship.shieldedDamage(ThreatZones.RED, 1);
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " attacks 2 on each zone.");
		ship.shieldedDamage(ThreatZones.BLUE, 2);
		ship.shieldedDamage(ThreatZones.WHITE, 2);
		ship.shieldedDamage(ThreatZones.RED, 2);
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks 3 on each zone.");
		ship.shieldedDamage(ThreatZones.BLUE, 3);
		ship.shieldedDamage(ThreatZones.WHITE, 3);
		ship.shieldedDamage(ThreatZones.RED, 3);
	}
		
	@Override
	public void move() {
		super.move();
		
		if ((!targetable)
		&& (getDistance() <= WeaponRanges.Range2.getMaximumDistance())) {
			targetable = true;
		}
	}
}
