package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class SE1_06 extends ExternalThreatBase {
	//Interstellarer Oktopus
	public SE1_06(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 4;
		scoreDestroyed= 8;
		
		setSpeed(2);
		setHealth(8);
		setShield(1);
		targetableByRockets = false;
	}

	@Override
	protected void doXAction() {
		if (getHealth() < 8) {
			Log.log(getName() + " attacks 1 on each zone.");
			ship.shieldedDamage(ThreatZones.BLUE, 1);
			ship.shieldedDamage(ThreatZones.WHITE, 1);
			ship.shieldedDamage(ThreatZones.RED, 1);
		} else {
			Log.log(getName() + " does nothing.");
		}
	}

	@Override
	protected void doYAction() {
		if (getHealth() < 8) {
			Log.log(getName() + " attacks 2 on each zone.");
			ship.shieldedDamage(ThreatZones.BLUE, 2);
			ship.shieldedDamage(ThreatZones.WHITE, 2);
			ship.shieldedDamage(ThreatZones.RED, 2);
		} else {
			Log.log(getName() + " does nothing.");
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks " + (2 * getHealth()) + ".");
		ship.shieldedDamage(getZone(), 2 * getHealth());
	}

}
