package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SE1_08 extends ExternalThreatBase {
	protected int destructionMultiplier;
	
	//Asteroid
	public SE1_08(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 4;
		scoreDestroyed= 8;
		
		setSpeed(3);
		setHealth(9);
		setShield(0);
		
		destructionMultiplier = 0;
	}

	@Override
	protected void doXAction() {
		destructionMultiplier += 1;
	}

	@Override
	protected void doYAction() {
		destructionMultiplier += 1;

	}
	
	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks " + getHealth() + ".");
		ship.shieldedDamage(getZone(), getHealth());
	}
	
	protected void attackAfterDestroyed() {
		if (destructionMultiplier > 0) {
			Log.log(getName() + " attacks " + (2 * destructionMultiplier) + ".");
			ship.shieldedDamage(getZone(), 2 * destructionMultiplier);
		}
	}

	@Override
	protected void destroy() {
		super.destroy();

		attackAfterDestroyed();
	}

}
