package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class SE1_101 extends ExternalThreatBase {
	//Trägerschiff
	public SE1_101(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 4;
		scoreDestroyed= 8;
		
		setSpeed(2);
		setHealth(6);
		setShield(3);
	}
	
	protected int reducedDamageByFighters(int damage) {
		if (ship.getFighters().isManned()) {
			damage -= 2;
			if (damage < 0) {
				damage = 0;
			}
		}
		return damage;
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks " + reducedDamageByFighters(2) + ".");
		ship.shieldedDamage(getZone(), reducedDamageByFighters(2));
	}

	@Override
	protected void doYAction() {
		int damage = reducedDamageByFighters(3);
		Log.log(getName() + " attacks " + damage + " on all other two zones.");
		if (getZone() != ThreatZones.RED) {
			ship.shieldedDamage(ThreatZones.RED, damage);
		}
		if (getZone() != ThreatZones.WHITE) {
			ship.shieldedDamage(ThreatZones.WHITE, damage);
		}
		if (getZone() != ThreatZones.BLUE) {
			ship.shieldedDamage(ThreatZones.BLUE, damage);
		}
	}

	@Override
	protected void doZAction() {
		int damage = reducedDamageByFighters(4);
		Log.log(getName() + " attacks " + damage + " on each zone.");
		ship.shieldedDamage(ThreatZones.BLUE, damage);
		ship.shieldedDamage(ThreatZones.WHITE, damage);
		ship.shieldedDamage(ThreatZones.RED, damage);
	}

}
