package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Movement;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.CardAction;
import spaceAlert.Log;
import threats.InternalMovingThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SI1_01 extends InternalMovingThreatBase {
	//Enterkommando
	public SI1_01(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 4;
		scoreDestroyed= 8;
		
		setSpeed(2);
		setHealth(2);
		fightsBack = true;
		tokenName = "Token SI1_01|02";
		location = ShipZones.RED_LOWER;
	}

	@Override
	protected void doXAction() {
		Movement.moveTo(this, CardAction.SWITCH_DECK);
	}

	@Override
	protected void doYAction() {
		if (getHealth() < 2) {
			Movement.moveTo(this, CardAction.MOVE_TO_BLUE);
		} else {
			Log.log(getName() + " deals 2 damage.");
			ship.damage(location.getThreatZone(), 2);
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 4 damage.");
		ship.damage(location.getThreatZone(), 4);
		Log.log(getName() + " knocks out players in " + location.getName() + ".");
		ship.knockOutPlayersIn(location);
	}

}
