package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Movement;
import ship.Player;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.CardAction;
import spaceAlert.Log;
import threats.InternalMovingThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SI1_03 extends InternalMovingThreatBase {
	//Alien
	public SI1_03(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = Integer.MIN_VALUE;
		scoreDestroyed= 8;
		
		setSpeed(2);
		setHealth(2);
		tokenName = "Token SI1_03";
		location = ShipZones.WHITE_LOWER;
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " grows up.");
		fightsBack = true;
	}

	@Override
	protected void doYAction() {
		Movement.moveTo(this, CardAction.SWITCH_DECK);
		int playerCount = 0;
		for (Player player: ship.getPlayers()) {
			if (player.getLocation() == location) {
				playerCount ++;
			}
		}
		Log.log(getName() + " deals " + playerCount + " damage.");
		ship.damage(location.getThreatZone(), playerCount);
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " takes over the ship.");
		ship.destroy(getName());
	}

}
