package whiteThreats;

import java.util.LinkedList;
import java.util.List;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalAttachedThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class SI1_04 extends InternalAttachedThreatBase {
	private boolean passedX = false;
	private boolean passedY = false;
	
	//Hüllenriss
	public SI1_04(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = Integer.MIN_VALUE;
		scoreDestroyed= 8;
		
		setSpeed(2);
		setHealth(2);
		
		action = "SI1_04";
		location = ShipZones.RED_UPPER;
		attachedTo = ship.getFighters();
	}
		
	@Override
	protected void destroy() {
		super.destroy();
		List<ThreatZones> repairedZones = new LinkedList<ThreatZones>();
		if (passedX) {
			repairedZones.add(location.getThreatZone());
		} else if (passedY) {
			repairedZones.add(ThreatZones.RED);
			repairedZones.add(ThreatZones.WHITE);
			repairedZones.add(ThreatZones.BLUE);
		}
		ship.removeDoubleDamageZones(repairedZones);
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " doubles all damages to " + location.getThreatZone().getName() + ".");
		passedX = true;
		List<ThreatZones> damagedZones = new LinkedList<ThreatZones>();
		damagedZones.add(location.getThreatZone());
		ship.addDoubleDamageZones(damagedZones);
	}

	@Override
	protected void doYAction() {
		if (!passedY) {
			Log.log(getName() + " doubles all damages to the ship.");
			passedY = true;
			List<ThreatZones> damagedZones = new LinkedList<ThreatZones>();
			if (ThreatZones.RED != location.getThreatZone()) {
				damagedZones.add(ThreatZones.RED);
			}
			if (ThreatZones.WHITE != location.getThreatZone()) {
				damagedZones.add(ThreatZones.WHITE);
			}
			if (ThreatZones.BLUE != location.getThreatZone()) {
				damagedZones.add(ThreatZones.BLUE);
			}
			ship.addDoubleDamageZones(damagedZones);
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " breaks the ship apart.");
		ship.destroy(getName());
	}

}
