package whiteThreats;

import java.util.List;

import pieces.Energy;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalAttachedThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class SI1_05 extends InternalAttachedThreatBase {
	//Fehlerhafte Verkabelung
	public SI1_05(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 4;
		scoreDestroyed= 8;
		
		setSpeed(3);
		setHealth(4);
		
		action = "B";
		location = ShipZones.WHITE_UPPER;
		attachedTo = ship.getWhiteShield();
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " transfers all energy from " + ship.getWhiteReactor().getName() + " to " + ship.getWhiteShield().getName() + ".");
		ship.getWhiteShield().loadWithEnergy(this, false);
		List<Energy> energies = ship.getWhiteReactor().getEnergy(Integer.MAX_VALUE);
		ship.damage(location.getThreatZone(), energies.size());
		for (Energy energy: energies) {
			energy.delete();
		}
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " leaks all energy from " + ship.getWhiteShield().getName() + ".");
		ship.damage(location.getThreatZone(), ship.getWhiteShield().getShieldStrength());
		ship.getWhiteShield().clear();
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " leaks all energy from each reactor.");
		List<Energy> energies = ship.getWhiteReactor().getEnergy(Integer.MAX_VALUE);
		ship.damage(ThreatZones.WHITE, energies.size());
		for (Energy energy: energies) {
			energy.delete();
		}
		energies.clear();
		
		energies.addAll(ship.getRedReactor().getEnergy(Integer.MAX_VALUE));
		ship.damage(ThreatZones.RED, energies.size());
		for (Energy energy: energies) {
			energy.delete();
		}
		energies.clear();
		
		energies.addAll(ship.getBlueReactor().getEnergy(Integer.MAX_VALUE));
		ship.damage(ThreatZones.BLUE, energies.size());
		for (Energy energy: energies) {
			energy.delete();
		}
	}

}
