package whiteThreats;

import VASSAL.counters.GamePiece;
import ship.Movement;
import ship.Player;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.CardAction;
import spaceAlert.Log;
import threats.InternalMovingThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SI1_101 extends InternalMovingThreatBase {
	//Raumflechte
	public SI1_101(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 4;
		scoreDestroyed= 8;
		
		setSpeed(2);
		setHealth(2);

		tokenName = "Token SI1_101";
		location = ShipZones.WHITE_LOWER;
	}

	@Override
	protected void doXAction() {
		for (Player player: ship.getPlayers()) {
			if (player.getLocation() == location) {
				Movement.moveTo(this, CardAction.MOVE_TO_BLUE);
				return;
			}
		}
		Log.log(getName() + " does nothing.");
	}

	@Override
	protected void doYAction() {
		for (Player player: ship.getPlayers()) {
			if (player.getLocation() == location) {
				Log.log(getName() + " deals 2 damage.");
				ship.damage(location.getThreatZone(), 2);
				return;
			}
		}
		Log.log(getName() + " heals 1 damage.");
		increaseHealth(1, 2);
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 4 damage.");
		ship.damage(location.getThreatZone(), 4);
	}

}
