package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import spaceAlert.Log;
import spaceAlert.ResolutionThread;
import spaceAlert.Space;
import threats.ExternalThreatBase;
import threats.ThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class E2_02 extends ExternalThreatBase {
	//Aufklärer
	public E2_02(Ship ship, GamePiece piece, TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(2);
		setHealth(3);
		setShield(1);
		
		targetableByHeavyLaser = false;
	}
	
	@Override
	protected void doXAction() {
		Log.log(getName() + " increases the attacks on all external threats.");
		ship.targetByScout(this);
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " advances each other external threat by 1.");
		for (ThreatBase threat: Space.getInstance().getThreats()) {
			if ((threat != this)
			&& (threat instanceof ExternalThreatBase)) {
				ExternalThreatBase externalThreat = (ExternalThreatBase) threat;
				if (externalThreat.isAppeared()
				&& !externalThreat.isDestroyed()
				&& !externalThreat.isPassedBy()
				&& !externalThreat.isPhasing()) {
					externalThreat.move(1);
					ResolutionThread.getInstance().doSleep();
				}
			}
		}

	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks 3 ignoring shields.");
		Log.log(getName() + " increases the attack by 1");
		ship.damage(getZone(), 4);
	}

	@Override
	protected void destroy() {
		ship.untargetByScout();
		
		super.destroy();
	}
}
