package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class E2_04 extends ExternalThreatBase {
	//Schwarm
	public E2_04(Ship ship, GamePiece piece, TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(2);
		setHealth(3);
		setShield(0);
		
		targetableByRockets = false;
	}

	@Override
	protected void doXAction() {
		ship.shieldedDamage(getZone(), 1);
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " attacks 2.");
		ship.shieldedDamage(getZone(), 2);
		Log.log(getName() + " attacks 1 on all other two zones.");
		if (ThreatZones.BLUE != getZone()) {
			ship.shieldedDamage(ThreatZones.BLUE, 1);
		}
		if (ThreatZones.WHITE != getZone()) {
			ship.shieldedDamage(ThreatZones.WHITE, 1);
		}
		if (ThreatZones.RED != getZone()) {
			ship.shieldedDamage(ThreatZones.RED, 1);
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks 3.");
		ship.shieldedDamage(getZone(), 3);
		Log.log(getName() + " attacks 2 on all other two zones.");
		if (ThreatZones.BLUE != getZone()) {
			ship.shieldedDamage(ThreatZones.BLUE, 2);
		}
		if (ThreatZones.WHITE != getZone()) {
			ship.shieldedDamage(ThreatZones.WHITE, 2);
		}
		if (ThreatZones.RED != getZone()) {
			ship.shieldedDamage(ThreatZones.RED, 2);
		}
	}
	
	protected int damageTakenThisRound = 0;
	@Override
	public void reset() {
		super.reset();
		
		damageTakenThisRound = 0;
	}
	
	@Override
	public void damageBy(WeaponBase weapon) {
		Log.log(getName() + " gets hit by " + weapon.getName());
		
		if (damageTakenThisRound == 0) {
			int damage = weapon.getDamage();
			if (damage > 0) {
				setHealth(getHealth() - 1);
				damageTakenThisRound = 1;
			}
		}
	}

}
