package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class E2_05 extends ExternalThreatBase {
	//Qualle
	public E2_05(Ship ship, GamePiece piece, TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(2);
		setHealth(13);
		setShield(-2);
		
		targetableByRockets = false;
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks 1 on each zones.");
		ship.shieldedDamage(ThreatZones.BLUE, 1);
		ship.shieldedDamage(ThreatZones.WHITE, 1);
		ship.shieldedDamage(ThreatZones.RED, 1);
		
		int recievedDamage = 13 - getHealth();
		int heals = (int)Math.floor(recievedDamage / 2);
		Log.log(getName() + " heals " + heals + " damage.");
		increaseHealth(heals, 13);
	}

	@Override
	protected void doYAction() {
		doXAction();
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks 2 on each zones.");
		ship.shieldedDamage(ThreatZones.BLUE, 2);
		ship.shieldedDamage(ThreatZones.WHITE, 2);
		ship.shieldedDamage(ThreatZones.RED, 2);
	}

}
