package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import spaceAlert.Log;
import spaceAlert.Space;
import threats.ExternalThreatBase;
import threats.ThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class E2_06 extends ExternalThreatBase {
	//Marodeur
	public E2_06(Ship ship, GamePiece piece, TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(3);
		setHealth(6);
		setShield(1);
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " increases the shield on all external threats.");
		for (ThreatBase threat: Space.getInstance().getThreats()) {
			if ((threat != this)
			&& (threat instanceof ExternalThreatBase)) {
				ExternalThreatBase externalThreat = (ExternalThreatBase) threat;
				if (!externalThreat.isDestroyed()
				|| !externalThreat.isPassedBy()) {
					externalThreat.increaseShield(1);
				}
			}
		}
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " drains 1 energy from each shield.");
		ship.getRedShield().recieveDamage(1);
		ship.getWhiteShield().recieveDamage(1);
		ship.getBlueShield().recieveDamage(1);
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks 4.");
		ship.shieldedDamage(getZone(), 4);
	}
	
	@Override
	protected void destroy() {
		for (ThreatBase threat: Space.getInstance().getThreats()) {
			if ((threat != this)
			&& (threat instanceof ExternalThreatBase)) {
				ExternalThreatBase externalThreat = (ExternalThreatBase) threat;
				if (!externalThreat.isDestroyed()
				|| !externalThreat.isPassedBy()) {
					externalThreat.decreaseShield(1);
				}
			}
		}
		
		super.destroy();
	}

}
