package yellowThreats;

import ship.Ship;
import spaceAlert.Log;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;
import VASSAL.counters.GamePiece;
import whiteThreats.SE1_101;

public class E2_101 extends SE1_101 {
	//Mini-Trägerschiff
	public E2_101(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(2);
		setHealth(5);
		setShield(2);
	}
	
	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks " + reducedDamageByFighters(2) + ".");
		ship.shieldedDamage(getZone(), reducedDamageByFighters(2));
	}

	@Override
	protected void doYAction() {
		int damage = reducedDamageByFighters(3);
		Log.log(getName() + " attacks " + damage + " on all other two zones.");
		if (getZone() != ThreatZones.RED) {
			ship.shieldedDamage(ThreatZones.RED, damage);
		}
		if (getZone() != ThreatZones.WHITE) {
			ship.shieldedDamage(ThreatZones.WHITE, damage);
		}
		if (getZone() != ThreatZones.BLUE) {
			ship.shieldedDamage(ThreatZones.BLUE, damage);
		}
	}

	@Override
	protected void doZAction() {
		int damage = reducedDamageByFighters(4);
		Log.log(getName() + " attacks " + damage + " on each zone.");
		ship.shieldedDamage(ThreatZones.BLUE, damage);
		ship.shieldedDamage(ThreatZones.WHITE, damage);
		ship.shieldedDamage(ThreatZones.RED, damage);
	}
}
