package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import threats.ThreatDamageSpecial;
import trajectoryBoards.TrajectoryBoardBase;

public class E2_102 extends ExternalThreatBase {
	//Oszillationsjäger
	public E2_102(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(3);
		setHealth(4);
		setShield(2);
	}
	
	@Override
	public void move() {
		if (isAppeared() 
		&& (distance > 0)) {
			setPhasing(isPhasing());
			if (isPhasing()) {
				ETAmarker.setProperty("oscillated", 1);
			} else {
				ETAmarker.setProperty("oscillated", 0);
			}
			super.move();
		}
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks 1.");
		ship.shieldedDamage(getZone(), 1);
	}

	@Override
	protected void doYAction() {
		if (isPhasing()) { //moving into oscillation
			Log.log(getName() + " attacks 2.");
			ship.shieldedDamage(getZone(), 2);
		} else { //returning from oscillation
			Log.log(getName() + " attacks 1.");
			ship.shieldedDamage(getZone(), 1, ThreatDamageSpecial.PHASING);
		}
	}

	@Override
	protected void doZAction() {
		if (isPhasing()) { //moving into oscillation
			Log.log(getName() + " attacks 3.");
			ship.shieldedDamage(getZone(), 3);
		} else { //returning from oscillation
			Log.log(getName() + " attacks 2.");
			ship.shieldedDamage(getZone(), 2, ThreatDamageSpecial.PHASING);
		}
	}

}
