package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import threats.ThreatDamageSpecial;
import trajectoryBoards.TrajectoryBoardBase;

public class E2_103 extends ExternalThreatBase {
	//Megaschildzerstörer
	public E2_103(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(2);
		setHealth(3);
		setShield(4);
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks 1.");
		ship.shieldedDamage(getZone(), 1, ThreatDamageSpecial.DOUBLED_DAMAGE);
	}

	@Override
	protected void doYAction() {
		doXAction();
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks 3.");
		ship.shieldedDamage(getZone(), 3, ThreatDamageSpecial.DOUBLED_DAMAGE);
	}

	@Override
	public void damageBy(WeaponBase weapon) {
		if ((remainingShield == getShield())
		&& (weapon.getDamage() > 0)) {
			decreaseShield(1);
		}
		super.damageBy(weapon);
	}
}
