package yellowThreats;

import java.util.EnumSet;
import java.util.List;

import pieces.Energy;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalAttachedThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class I2_05 extends InternalAttachedThreatBase {
	//Virus
	public I2_05(Ship ship, GamePiece piece, TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(3);
		setHealth(3);
		
		action = "C";
		location = ShipZones.WHITE_UPPER;
		attachedTo = ship.getComputer();
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " drains 1 energy from each reactor.");
		List<Energy> energies = ship.getRedReactor().getEnergy(1);
		energies.addAll(ship.getWhiteReactor().getEnergy(1));
		energies.addAll(ship.getBlueReactor().getEnergy(1));
		
		for (Energy energy: energies) {
			energy.delete();
		}
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " delays each player on ship.");
		EnumSet<ShipZones> zones = EnumSet.range(ShipZones.RED_UPPER, ShipZones.BLUE_LOWER);
		for (ShipZones zone: zones) {
			ship.delayPlayersIn(zone);
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 1 damage in each zone.");
		ship.damage(ThreatZones.RED, 1);
		ship.damage(ThreatZones.WHITE, 1);
		ship.damage(ThreatZones.BLUE, 1);
	}

}
