package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalAttachedThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class I2_06 extends InternalAttachedThreatBase {
	//Überhitzter Reaktor
	public I2_06(Ship ship, GamePiece piece, TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(2);
		setHealth(3);
		
		action = "B";
		location = ShipZones.WHITE_LOWER;
		attachedTo = ship.getWhiteReactor();
	}
	
	@Override
	protected void destroy() {
		super.destroy();
		Log.log(getName() + " knocks out player in " + ShipZones.RED_LOWER.getName() + " and " + ShipZones.BLUE_LOWER.getName() + ".");
		ship.knockOutPlayersIn(ShipZones.RED_LOWER);
		ship.knockOutPlayersIn(ShipZones.BLUE_LOWER);
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " deals " + ship.getWhiteReactor().getEnergyCount() + " damage.");
		ship.damage(getZone(), ship.getWhiteReactor().getEnergyCount());
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " consumes one fuel.");
		ship.getWhiteReactor().consumeFuel();
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 3 damage.");
		ship.damage(getZone(), 3);
	}

}
