package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipComponentBase;
import ship.ShipZones;
import spaceAlert.Log;
import spaceAlert.Nameable;
import threats.InternalMultipleAttachedThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class I2_101 extends InternalMultipleAttachedThreatBase {
	//Kurzschluß im Batteriepack
	public I2_101(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(3);
		setHealth(4);
		
		action = "A";
		location = ShipZones.RED_LOWER;
		additionalLocation.add(ShipZones.BLUE_LOWER);
		attachedTo = ship.getRedLightLaser();
		additionalAttachedTo.add(ship.getBlueBattleBots());
	}
	
	private ShipComponentBase damagedAtStation = null;
	
	@Override
	public void damage(Nameable player, ShipComponentBase station, boolean isHeroic) {
		super.damage(player, station, isHeroic);
		
		if (damagedAtStation == null) {
			damagedAtStation = station;
		} else if (damagedAtStation != station) {
			setHealth(getHealth() - 1);
			damagedAtStation = null;
		}
	}
	
	@Override
	public void reset() {
		super.reset();
		
		damagedAtStation = null;
	}
	
	@Override
	protected void doXAction() {
		Log.log(getName() + " destroys one rocket.");
		ship.getRocketThrower().deleteRocket(this);
		if (!ship.getRedBattleBots().isFollowing()) {
			Log.log(getName() + " damages red battlebot squad.");
			ship.getRedBattleBots().damage();
		}
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " heals 1 damage.");
		increaseHealth(1, 4);
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " knocks out player in " + ShipZones.RED_LOWER.getName() + " and " + ShipZones.BLUE_LOWER.getName() + ".");
		ship.knockOutPlayersIn(ShipZones.RED_LOWER);
		ship.knockOutPlayersIn(ShipZones.BLUE_LOWER);
		Log.log(getName() + " attacks 3 in " + ThreatZones.RED.getName() + " and " + ThreatZones.BLUE.getName() + ".");
		ship.damage(ThreatZones.RED, 3);
		ship.damage(ThreatZones.BLUE, 3);
	}

}
