package yellowThreats;

import java.util.LinkedList;
import java.util.List;

import pieces.Energy;
import VASSAL.counters.GamePiece;
import ship.Movement;
import ship.Player;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalMovingThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class I2_102 extends InternalMovingThreatBase {
	//Attentäter
	public I2_102(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 3;
		scoreDestroyed= 6;
		
		setSpeed(2);
		setHealth(3);
		fightsBack = false;
		tokenName = "Token I2_102";
		location = ShipZones.BLUE_LOWER;
	}
	
	private List<Player> players = new LinkedList<Player>(); 
	
	public void infect(Player player) {
		Log.log(getName() + " poisons " + player.getName());
		players.add(player);
		player.poison();
	}
	
	@Override
	protected void destroy() {
		super.destroy();
		Movement.unInfect();
	}
	@Override
	protected void passeBy() {
		super.passeBy();
		Movement.unInfect();
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " sends drones to neighbor stations.");
		Movement.infect(this);
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " drains 1 energy from " + ship.getBlueReactor().getName() + ".");
		List<Energy> energies = ship.getBlueReactor().getEnergy(1);
		for (Energy energy: energies) {
			energy.delete();
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " launches all rockets.");
		int count = ship.getRocketThrower().getRocketCount();
		Log.log("Rockets deals " + (count * 2) + " damage.");
		ship.damage(ThreatZones.BLUE, count * 2);
		ship.getRocketThrower().clear();
		
		Log.log("Poisened players are knocked out.");
		for (Player player: players) {
			player.knockOut();
		}
	}

}
