package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Fighters;
import ship.GenericDamageDealer;
import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SE2_01 extends ExternalThreatBase {
	//Behemoth
	public SE2_01(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 6;
		scoreDestroyed= 12;
		
		setSpeed(2);
		setHealth(7);
		setShield(4);
	}

	@Override
	protected void doXAction() {
		if (getHealth() > 5) {
			Log.log(getName() + " attacks 2.");
			ship.shieldedDamage(getZone(), 2);
		} else {
			Log.log(getName() + " does nothing.");
		}
	}

	@Override
	protected void doYAction() {
		if (getHealth() > 4) {
			Log.log(getName() + " attacks 3.");
			ship.shieldedDamage(getZone(), 3);
		} else {
			Log.log(getName() + " does nothing.");
		}
	}

	@Override
	protected void doZAction() {
		if (getHealth() > 1) {
			Log.log(getName() + " attacks 6.");
			ship.shieldedDamage(getZone(), 6);
		} else {
			Log.log(getName() + " does nothing.");
		}
	}
	
	@Override
	public void damageBy(WeaponBase weapon) {
		super.damageBy(weapon);
		if (weapon instanceof Fighters) {
			Fighters fighters = (Fighters) weapon;
			if (fighters.getDamage() == 3) {
				fighters.getManned().knockOut();
				super.damageBy(new GenericDamageDealer("additional fighters damage", 6));
			}	
		}
	}
}
