package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.RocketThrower;
import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SE2_02 extends ExternalThreatBase {
	//Juggernaut
	public SE2_02(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 6;
		scoreDestroyed= 12;
		
		setSpeed(1);
		setHealth(10);
		setShield(3);
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks 2.");
		ship.shieldedDamage(getZone(), 2);
		Log.log(getName() + " increases its speed.");
		increaseSpeed(2);
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " attacks 3.");
		ship.shieldedDamage(getZone(), 3);
		Log.log(getName() + " increases its speed.");
		increaseSpeed(2);
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " attacks 7.");
		ship.shieldedDamage(getZone(), 7);
	}
	
	@Override
	public void damageBy(WeaponBase weapon) {
		super.damageBy(weapon);
		if (weapon instanceof RocketThrower) {
			Log.log(getName() + " increases its shield.");
			increaseShield(1);
		}
	}

}
