package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import trajectoryBoards.TrajectoryBoardBase;
import whiteThreats.SE1_04;

public class SE2_03 extends SE1_04 {
	//Psionischer Satellit
	public SE2_03(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 6;
		scoreDestroyed= 12;
		
		setSpeed(2);
		setHealth(5);
		setShield(2);		
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " delays each players in " + getZone().getName() + ".");
		switch (getZone()) {
		case BLUE:
			ship.delayPlayersIn(ShipZones.BLUE_LOWER);
			ship.delayPlayersIn(ShipZones.BLUE_UPPER);
			break;
		case RED:
			ship.delayPlayersIn(ShipZones.RED_LOWER);
			ship.delayPlayersIn(ShipZones.RED_UPPER);
			break;
		case WHITE:
			ship.delayPlayersIn(ShipZones.WHITE_LOWER);
			ship.delayPlayersIn(ShipZones.WHITE_UPPER);
			break;
		default:
			break;
		}
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " delays all players.");
		for (ShipZones zone: ShipZones.values()) {
			ship.delayPlayersIn(zone);
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " knocks out all players.");
		for (ShipZones zone: ShipZones.values()) {
			ship.knockOutPlayersIn(zone);
		}
	}

}
