package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import threats.ExternalThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class SE2_05 extends ExternalThreatBase {
	//Nemesis
	public SE2_05(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = Integer.MIN_VALUE;
		scoreDestroyed= 12;
		
		setSpeed(3);
		setHealth(9);
		setShield(1);
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " attacks 1.");
		ship.shieldedDamage(getZone(), 1);
		Log.log(getName() + " damages itself.");
		decreaseHealth(1);
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " attacks 2.");
		ship.shieldedDamage(getZone(), 2);
		Log.log(getName() + " damages itself.");
		decreaseHealth(2);
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " destroys itself and the ship.");
		ship.shieldedDamage(getZone(), Integer.MAX_VALUE);
		decreaseHealth(getHealth());
	}

	private boolean damaged = false;
	@Override
	public void damageBy(WeaponBase weapon) {
		if (weapon.getDamage() > 0) {
			damaged = true;
		}
		super.damageBy(weapon);
	}
	
	@Override
	public void reset() {
		super.reset();
		
		if (damaged) {
			Log.log(getName() + " attacks 1 on each zone.");
			ship.shieldedDamage(ThreatZones.RED, 1);
			ship.shieldedDamage(ThreatZones.WHITE, 1);
			ship.shieldedDamage(ThreatZones.BLUE, 1);
		};
		damaged = false;
	}
}
