package yellowThreats;

import ship.Ship;
import spaceAlert.Log;
import threats.ThreatDamageSpecial;
import trajectoryBoards.TrajectoryBoardBase;
import VASSAL.counters.GamePiece;

public class SE2_102 extends E2_102 {
	//Oszillationsfregatte
	public SE2_102(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 6;
		scoreDestroyed= 12;
		
		setSpeed(2);
		setHealth(7);
		setShield(2);
	}
	
	@Override
	protected void doXAction() {
		if (isPhasing()) { //moving into oscillation
			Log.log(getName() + " attacks 2.");
			ship.shieldedDamage(getZone(), 2);
		} else { //returning from oscillation
			Log.log(getName() + " attacks 1.");
			ship.shieldedDamage(getZone(), 1, ThreatDamageSpecial.PHASING);
		}
	}

	@Override
	protected void doYAction() {
		if (isPhasing()) { //moving into oscillation
			Log.log(getName() + " attacks 3.");
			ship.shieldedDamage(getZone(), 3);
		} else { //returning from oscillation
			Log.log(getName() + " attacks 2.");
			ship.shieldedDamage(getZone(), 2, ThreatDamageSpecial.PHASING);
		}
	}

	@Override
	protected void doZAction() {
		if (isPhasing()) { //moving into oscillation
			Log.log(getName() + " attacks 4.");
			ship.shieldedDamage(getZone(), 4);
		} else { //returning from oscillation
			Log.log(getName() + " attacks 3.");
			ship.shieldedDamage(getZone(), 3, ThreatDamageSpecial.PHASING);
		}
	}
}
