package yellowThreats;

import ship.Ship;
import ship.WeaponBase;
import spaceAlert.Log;
import trajectoryBoards.TrajectoryBoardBase;
import VASSAL.counters.GamePiece;

public class SE2_103 extends E2_04 {
	//Riesenschwarm
	public SE2_103(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 6;
		scoreDestroyed= 12;
		
		setSpeed(2);
		setHealth(6);
		setShield(1);
		
		targetableByRockets = false;
	}

	@Override
	public void damageBy(WeaponBase weapon) {
		Log.log(getName() + " gets hit by " + weapon.getName());
		
		int damage = weapon.getDamage();
		if (remainingShield - damage >= 0) {
			remainingShield -= damage;
		} else {
			damage = damage - remainingShield;
			remainingShield = 0;
			
			switch (damageTakenThisRound) {
			case 1:
				setHealth(getHealth() - 1);
				damageTakenThisRound = 2;
				break;
			case 0:
				if (damage > 1) {
					setHealth(getHealth() - 2);
					damageTakenThisRound = 2;
				} else {
					setHealth(getHealth() - 1);
					damageTakenThisRound = 1;
				}
				break;
			default:
				break;
			}
		}
	}
}
