package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Movement;
import ship.Player;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.CardAction;
import spaceAlert.Log;
import threats.InternalMovingThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SI2_01 extends InternalMovingThreatBase {
	//Executor
	public SI2_01(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 6;
		scoreDestroyed= 12;
		
		setSpeed(2);
		setHealth(2);
		fightsBack = true;
		
		tokenName = "Token SI2_01";
		location = ShipZones.BLUE_LOWER;
	}

	@Override
	protected void doXAction() {
		Movement.moveTo(this, CardAction.MOVE_TO_RED);
		knocksOutPlayers();
	}

	private void knocksOutPlayers() {
		for (Player player: ship.getPlayers()) {
			if ((player.getLocation() == getLocation())
			&& !player.hasBattlebots()) {
				Log.log(getName() + " knocks out " + player.getName());
				player.knockOut();
			}
		}
	}

	@Override
	protected void doYAction() {
		Movement.moveTo(this, CardAction.SWITCH_DECK);
		knocksOutPlayers();
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 3 damage.");
		ship.damage(getZone(), 3);
	}

}
