package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Player;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalMovingThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SI2_02 extends InternalMovingThreatBase {
	//Späherdroide
	public SI2_02(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 6;
		scoreDestroyed= 15;
		
		setSpeed(2);
		setHealth(2);
	
		tokenName = "Token SI2_02";
		location = ShipZones.WHITE_UPPER;
	}

	@Override
	protected void doXAction() {
		ShipZones[] neighbor = getLocation().getNeighbour();
		int[] neighborCount = getPlayerCountAtLocations(neighbor);
		ShipZones target = getLocation();
		int playerCountInTarget = 0;
		boolean foundSimilarCount = false;
		for (int i = 0; i < neighbor.length; i++) {
			if (neighborCount[i] > playerCountInTarget) {
				target = neighbor[i];
				playerCountInTarget = neighborCount[i];
				foundSimilarCount = false;
			} else if (neighborCount[i] == playerCountInTarget) {
				foundSimilarCount = true;
			}
		}
		if (!foundSimilarCount) {
			if (ship.isMovementAllowed(getLocation(), target)) {
				moveTo(target);
			}
		}
	}

	private int[] getPlayerCountAtLocations(ShipZones[] locations) {
		int[] neighborCount = new int[locations.length];
		for (int i = 0; i < locations.length; i++) {
			neighborCount[i] = 0;
		}
		for (Player player: ship.getPlayers()) {
			for (int i = 0; i < locations.length; i++) {
				if (player.getLocation() == locations[i]) {
					neighborCount[i]++;
					break;
				}
			}
		}
		return neighborCount;
	}

	@Override
	protected void doYAction() {
		doXAction();
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 5 damage.");
		ship.damage(getZone(), 5);
		Log.log(getName() + " knocks out players at " + getLocation().getName() + ".");
		ship.knockOutPlayersIn(getLocation());
	}

}
