package yellowThreats;

import java.util.List;

import pieces.Energy;
import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipComponentBase;
import ship.ShipZones;
import spaceAlert.Log;
import spaceAlert.Nameable;
import threats.InternalMultipleAttachedThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class SI2_03 extends InternalMultipleAttachedThreatBase {
	//Überlastete Energieversorgung
	public SI2_03(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 6;
		scoreDestroyed= 12;
		
		setSpeed(3);
		setHealth(4);
		
		action = "B";
		location = ShipZones.RED_LOWER;
		additionalLocation.add(ShipZones.WHITE_LOWER);
		additionalLocation.add(ShipZones.BLUE_LOWER);
		attachedTo = ship.getRedReactor();
		additionalAttachedTo.add(ship.getWhiteReactor());
		additionalAttachedTo.add(ship.getBlueReactor());
	}
	
	private ShipComponentBase firstDamager = null;
	private ShipComponentBase secondDamager = null;
	
	@Override
	public void damage(Nameable player, ShipComponentBase station, boolean isHeroic) {
		super.damage(player, station, isHeroic);
		
		if (firstDamager == null) {
			firstDamager = station;
		} else {
			if (firstDamager != station) {
				if (secondDamager == null) {
					secondDamager = station;
				} else {
					setHealth(getHealth() - 2);
					firstDamager = null;
					secondDamager = null;
				}
			}
		}
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " drains 2 energy from " + ship.getWhiteReactor().getName() + ".");
		List<Energy> energies = ship.getWhiteReactor().getEnergy(2);
		for (Energy energy: energies) {
			energy.delete();
		}
	}

	@Override
	protected void doYAction() {
		Log.log(getName() + " drains 1 energy from each reactor.");
		List<Energy> energies = ship.getRedReactor().getEnergy(1);
		energies.addAll(ship.getWhiteReactor().getEnergy(1));
		energies.addAll(ship.getBlueReactor().getEnergy(1));
		
		for (Energy energy: energies) {
			energy.delete();
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " deals 3 damage in each zones.");
		ship.damage(ThreatZones.RED, 3);
		ship.damage(ThreatZones.WHITE, 3);
		ship.damage(ThreatZones.BLUE, 3);
	}

}
