package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Player;
import ship.Ship;
import ship.ShipZones;
import threats.InternalMovingThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SI2_04_child extends InternalMovingThreatBase {
	private SI2_04 parent;
	public SI2_04_child(SI2_04 parent, Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard, ShipZones location) {
		super(ship, piece, trajectoryBoard);

		scoreSurvived = 0;
		scoreDestroyed= 0;
		
		setSpeed(2);
		setHealth(1);
		
		this.parent = parent;
		
		tokenName = "Token SI2_04";
		this.location = location;
	}
	
	@Override
	public String getName() {
		return parent.getName();
	}
	
	@Override
	protected void createETAmarker() {}
	
	@Override
	public void damageBy(Player player, boolean isHeroic) {
		if (player.hasBattlebots()
		&& !player.getBattlebots().isDamaged()) {
			setHealth(0);
			parent.damageBy(player, isHeroic);
		}
	}
	
	@Override
	public void destroy() {
		super.destroy();
	}

	@Override
	protected void doXAction() {}

	@Override
	protected void doYAction() {}

	@Override
	protected void doZAction() {}

}
