package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalAttachedShieldedThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SI2_05 extends InternalAttachedShieldedThreatBase {
	//Nuklearer Gefechtskopf
	public SI2_05(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = Integer.MIN_VALUE;
		scoreDestroyed= 12;
		
		setSpeed(4);
		setHealth(1);
		setShield(2);
		
		action = "C";
		location = ShipZones.WHITE_LOWER;
		attachedTo = ship.getWindow();
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " increases its speed.");
		increaseSpeed(1);
	}

	@Override
	protected void doYAction() {
		doXAction();
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " destroys the ship.");
		ship.damage(getZone(), Integer.MAX_VALUE);
	}

}
