package yellowThreats;

import VASSAL.counters.GamePiece;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.Log;
import threats.InternalAttachedShieldedThreatBase;
import threats.ThreatZones;
import trajectoryBoards.TrajectoryBoardBase;

public class SI2_101 extends InternalAttachedShieldedThreatBase {
	//Oszillationsanomalie
	public SI2_101(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 6;
		scoreDestroyed= 12;
		
		setSpeed(3);
		setHealth(2);
		setShield(1);
		
		action = "C";
		location = ShipZones.WHITE_UPPER;
		attachedTo = ship.getWindow();
	}
	
	@Override
	public void move() {
		if (isAppeared() 
		&& (distance > 0)) {
			setPhasing(isPhasing());
			if (isPhasing()) {
				ETAmarker.setProperty("oscillated", 1);
			} else {
				ETAmarker.setProperty("oscillated", 0);
			}
			super.move();
		}
	}

	@Override
	protected void doXAction() {
		Log.log(getName() + " disrupts " + ThreatZones.WHITE.getName() + " optics.");
		ship.getOptics().damageOptics(ThreatZones.WHITE);
	}

	private boolean passedFirstY = false;
	@Override
	protected void doYAction() {
		if (!passedFirstY) {
			Log.log(getName() + " disrupts " + ThreatZones.RED.getName() + " optics.");
			ship.getOptics().damageOptics(ThreatZones.RED);
			passedFirstY = true;
		} else {
			Log.log(getName() + " disrupts " + ThreatZones.BLUE.getName() + " optics.");
			ship.getOptics().damageOptics(ThreatZones.BLUE);
		}
	}

	@Override
	protected void doZAction() {
		Log.log(getName() + " knocks out each player in " + ShipZones.WHITE_UPPER.getName() + " and " + ShipZones.WHITE_LOWER.getName() + ".");
		ship.knockOutPlayersIn(ShipZones.WHITE_UPPER);
		ship.knockOutPlayersIn(ShipZones.WHITE_LOWER);
	}

	@Override
	protected void destroy() {
		super.destroy();
		
		ship.getOptics().repairOptics();
	}
}
