package yellowThreats;

import java.util.LinkedList;
import java.util.List;

import VASSAL.counters.GamePiece;
import ship.Movement;
import ship.Ship;
import ship.ShipZones;
import spaceAlert.CardAction;
import spaceAlert.Log;
import threats.InternalMovingThreatBase;
import trajectoryBoards.TrajectoryBoardBase;

public class SI2_102 extends InternalMovingThreatBase {

	public SI2_102(Ship ship, GamePiece piece,
			TrajectoryBoardBase trajectoryBoard) {
		super(ship, piece, trajectoryBoard);
		
		scoreSurvived = 6;
		scoreDestroyed= 12;
		
		setSpeed(2);
		setHealth(2);
		fightsBack = true;
		tokenName = "Token SI2_102";
		location = ShipZones.WHITE_UPPER;
	}
	
	@Override
	public void move() {
		if (isAppeared() 
		&& (distance > 0)) {
			setPhasing(isPhasing());
			if (isPhasing()) {
				ETAmarker.setProperty("oscillated", 1);
			} else {
				ETAmarker.setProperty("oscillated", 0);
			}
			super.move();
		}
	}
	
	protected List<SI2_102_bomb> bombs = new LinkedList<SI2_102_bomb>();
	protected void placeBomb() {
		Log.log(getName() + " places a bomb.");
		SI2_102_bomb bomb = new SI2_102_bomb(map, getLocation());
		bombs.add(bomb);
	}

	@Override
	protected void doXAction() {
		placeBomb();
		if (isPhasing()) {
			Movement.moveTo(this, CardAction.MOVE_TO_RED);
		} else {
			Movement.moveTo(this, CardAction.MOVE_TO_BLUE);
		}
	}

	@Override
	protected void doYAction() {
		placeBomb();
		Movement.moveTo(this, CardAction.SWITCH_DECK);
	}

	@Override
	protected void doZAction() {
		placeBomb();
		Log.log(getName() + " detonates its bombs.");
		for (SI2_102_bomb bomb: bombs) {
			Log.log(getName() + "'s bomb attacks 2.");
			ship.damage(bomb.getLocation().getThreatZone(), 2);
			bomb.delete();
		}
	}

}
